/*
2017-2018 Aron Barath

This file has been put into the public domain.
You can do whatever you want with this file.
*/

#include "ptrarr.h"
#include <stdlib.h>
#include <string.h>

#define DEFAULT_CAPACITY 16

void ptrarr_init(struct ptrarr* const arr)
{
	memset(arr, 0, sizeof(*arr));

	if(NULL==(arr->pointers=(void**)malloc(sizeof(void*)*DEFAULT_CAPACITY)))
	{
		abort();
	}

	arr->capacity = DEFAULT_CAPACITY;
}

void ptrarr_deinit(struct ptrarr* const arr)
{
	free(arr->pointers);
}

void ptrarr_add(struct ptrarr* const arr, void* const ptr)
{
	if(arr->size==arr->capacity)
	{
		if(NULL==(arr->pointers=(void**)realloc(arr->pointers, 2*sizeof(void*)*arr->capacity)))
		{
			abort();
		}

		arr->capacity *= 2;
	}

	arr->pointers[arr->size++] = ptr;
}

void ptrarr_remove(struct ptrarr* const arr, size_t index)
{
	/* sanity check -- maybe a little bit too harsh, but who cares */
	if(index>=arr->size) { abort(); }

	if((index+1)<arr->size)
	{
		arr->pointers[index] = arr->pointers[arr->size-1];
	}

	--arr->size;
}
